#include <TFile.h>
#include <TCanvas.h>
#include <TH2D.h>
#include <TH1D.h>
#include <TGraph.h>
#include <TString.h>
#include <TStyle.h>
#include <TColor.h>
#include <TChain.h>
#include <TMath.h>
#include <TROOT.h>
#include <TGaxis.h>
#include <TList.h>
#include <TObjArray.h>
#include <TLegend.h>

#include <stdlib.h>
#include <iostream>
#include <vector>


//ve tren root 6
//Subfunctions
void PrintHisto(TCanvas *canvas, TString name);
std::vector<TGraph*> GetContourGraphs(TObjArray *contours, TString color, int twotheta, int graphNum);
void PreparePlot(TH2D* plot);
void PrepareBestPoint(TGraph* gr);
void SetStyleVariables(TStyle *t2kStyle);
void plot_th23dcp(){
    //**** Set Style for Plots ****
    TStyle *t2kstyle = new TStyle("NU","NU approved plots style");
    SetStyleVariables(t2kstyle);
    gROOT->SetStyle("NU");
    
    TChain *Sensi = new TChain("SensiTree");
    Sensi->Add("sensi/allexp/allexp_th23known_0.47/th23dcp_*.root");
    std::cout << "Sensi Tree: " << Sensi->GetEntries() << std::endl;
    
    double dcptest = 0;
    double dcptrue = 0;
    double th23test = 0;
    int binIndexx = 0;
    int binIndexy = 0;
    int binIndexytrue;
    double Chisq = 0.;
    Sensi->SetBranchAddress("dcptest", &dcptest);
    Sensi->SetBranchAddress("dcptrue", &dcptrue);
    Sensi->SetBranchAddress("th23test", &th23test);
    Sensi->SetBranchAddress("binIndexx", &binIndexx);
    Sensi->SetBranchAddress("binIndexy", &binIndexy);
    Sensi->SetBranchAddress("binIndexytrue", &binIndexytrue);
    Sensi->SetBranchAddress("Chisq", &Chisq);
    //the bining here is different from app/FitterSetting
    //TH2D *SA_th23dcp = new TH2D("SA_th23dcp", "AsimovA Sensitivity", 51, -0.01, 1.01, 101, -0.01e-2, 2.01e-2);
    //TH2D *SA_th23dcp = new TH2D("SA_th23dcp", "AsimovA Sensitivity", 51,0.796 , 1.204, 21, 1.975e-3, 3.025e-3);
    double th23min = asin(sqrt(0.296));
    double th23max = asin(sqrt(0.704));
    int NPOINTTH23 = 51;
    double th23step = 0.008; //(th23max-th23min)/(1.*NPOINTTH23);
    
    double dcpmin = -1.02;
    int NPOINT = 51;
    double dcpstep = 0.04;
    double dcpmax = 1.02;//dcpmin+(NPOINT)*dcpstep;
    
    double M = TMath::Pi();
    
    
    
    
    TH3D *SA_th23dcp3D = new TH3D("SA_th23dcp3D", "", NPOINTTH23,0.296,0.704,NPOINT,dcpmin*M,dcpmax*M,NPOINT,dcpmin*M,dcpmax*M);
    //find minimize
    double globalmin = 999999.;
    double th23Testmin = 0;
    double dcpTestmin = 0;
    double dcpTruemin = 0;
    
    TH2D *SA_th23dcp = new TH2D("SA_th23dcp", "",NPOINTTH23,0.296,0.704,NPOINT,dcpmin*M,dcpmax*M);
 
    TH2D *SA_dcpTrue_dcpTest = new TH2D("SA_dcpTrue_dcpTest", "",NPOINT,dcpmin*M,dcpmax*M,NPOINT,dcpmin*M,dcpmax*M);

    TH2D *SA_dcpTrue_dcpTestRaw = new TH2D("SA_dcpTrue_dcpTestRaw", "", NPOINT,dcpmin*M,dcpmax*M,NPOINT,dcpmin*M,dcpmax*M);

    for (int ix = 1; ix <= SA_th23dcp->GetNbinsX(); ix++){
        for (int iy = 1; iy <= SA_th23dcp->GetNbinsY(); iy++){
            SA_th23dcp->SetBinContent(ix,iy,globalmin);
            
        }
    }
    for (int ix = 1; ix <= SA_dcpTrue_dcpTest->GetNbinsX(); ix++){
        for (int iy = 1; iy <= SA_dcpTrue_dcpTest->GetNbinsY(); iy++){
            SA_dcpTrue_dcpTest->SetBinContent(ix,iy,globalmin);
            
        }
    }
    for(int i=0; i<Sensi->GetEntries(); i++){
        Sensi->GetEntry(i);
        if(Chisq<0) Chisq=0;
        if(Chisq<globalmin) {globalmin = Chisq;
            th23Testmin = th23test;
            dcpTestmin = dcptest;
            dcpTruemin = dcptrue;
        }
    }
    cout <<"min chisquare "<<globalmin<<" at dcp true "<<dcpTruemin<<" dcp test "<<dcpTestmin<<" th23 "<<th23Testmin<<endl;
    
    for(int i=0; i<Sensi->GetEntries(); i++){
        Sensi->GetEntry(i);
        //debug
        //cout<<"at dm23" <<OscParams[2]<<" sin23 "<<OscParams[3]<<" likelihood "<<Chisq<<endl;
        //SA_th23dcp->SetBinContent(SA_th23dcp->FindBin(OscParams[3], OscParams[2]), Chisq);
        //after subtracting the minimal values
        //SA_th23dcp->SetBinContent(SA_th23dcp->FindBin(th23test, dcptest), (Chisq-globalmin));
        double chisqsub = Chisq-globalmin;
        SA_th23dcp3D->SetBinContent(SA_th23dcp3D->FindBin(th23test, dcptest,dcptrue), chisqsub);
        
        if (SA_th23dcp->GetBinContent(SA_th23dcp->FindBin(th23test,dcptrue))>chisqsub) {
            SA_th23dcp->SetBinContent(SA_th23dcp->FindBin(th23test,dcptrue),chisqsub);
        }

        if (SA_dcpTrue_dcpTest->GetBinContent(SA_dcpTrue_dcpTest->FindBin(dcptest,dcptrue))>chisqsub) {
            SA_dcpTrue_dcpTest->SetBinContent(SA_dcpTrue_dcpTest->FindBin(dcptest,dcptrue),chisqsub);
            SA_dcpTrue_dcpTestRaw->SetBinContent(SA_dcpTrue_dcpTest->FindBin(dcptest, dcptrue), Chisq);
        }
        //make a projection on dcpTrue vs theta23 test
        
    }

     //make a projection on true dCP
    TH1D *dcptrue_rej = new TH1D("dcptrue_rej","",NPOINT,dcpmin*M,dcpmax*M);
    for (Int_t ibin=1; ibin<=NPOINT; ++ibin) {
        double chisqmean = 999.;
        for (Int_t ibinx=1; ibinx<=NPOINT; ++ibinx) {
        if(chisqmean>SA_dcpTrue_dcpTest->GetBinContent(ibinx,ibin))
        chisqmean = SA_dcpTrue_dcpTest->GetBinContent(ibinx,ibin);
        }
        if(chisqmean<0){
        chisqmean =0;
        dcptrue_rej->SetBinContent(ibin,sqrt(chisqmean));
         }
        else
        dcptrue_rej->SetBinContent(ibin,sqrt(chisqmean));
    }
   

    //make a projection on true dcp for cpviolation
    TH1D *cpviolation = new TH1D("cpviolation","",NPOINT,dcpmin*M,dcpmax*M);   
    
    for (int iy=1; iy <= NPOINT; iy++){
            double_t dcptest[NPOINT], chisq[NPOINT];
            double dchisqmin = 99999;
            double_t a[3]; 
        for (int ix =1; ix <= NPOINT; ix++){
            
            chisq[ix] = SA_dcpTrue_dcpTest->GetBinContent(ix,iy);
            dcptest[ix] = SA_dcpTrue_dcpTest->GetXaxis()->GetBinCenter(ix);
            //find delta_chisqua min
            double dchisq = SA_dcpTrue_dcpTest->GetBinContent(ix,iy);
            if(dchisq<dchisqmin)
               {
                dchisqmin = dchisq;
                }
               
            //cout<<" bin "<<ix<<" deltachisq "<< dchisq<<endl;
            
            /*double dchisq0 = SA_dcpTrue_dcpTest->GetBinContent(26,iy);
            double dchisqpi = SA_dcpTrue_dcpTest->GetBinContent(51,iy);
            double dchisq_cpv = dchisq0;*/
            int binx0, binxpi, binxmpi;
            
            binx0 = SA_dcpTrue_dcpTest->GetXaxis()->FindBin(0.);
            binxpi = SA_dcpTrue_dcpTest->GetXaxis()->FindBin(M);
            binxmpi = SA_dcpTrue_dcpTest->GetXaxis()->FindBin(-M);
            //cout<<" bin "<<iy<<";  "<< binx0 << "; " << binxpi << "; " << binxmpi << endl;
            a[0] = SA_dcpTrue_dcpTest->GetBinContent(binx0 , iy);
            a[1] = SA_dcpTrue_dcpTest->GetBinContent(binxpi , iy);
            a[2] = SA_dcpTrue_dcpTest->GetBinContent(binxmpi , iy);
            }
            double min=a[0];
            for (int i = 0; i<3;i++){
            if (min > a[i]){
            min =a[i];
            }
            }

            cpviolation->SetBinContent(iy,sqrt((min - dchisqmin)));
            }
            /*if(dchisq_cpv > dchisqpi)
               {
                dchisq_cpv=dchisqpi;
               }
            cpviolation->SetBinContent(iy,sqrt((dchisq_cpv - dchisqmin)));
            
            cout<<" bin "<<iy<<" cpviolation "<< sqrt((dchisq_cpv - dchisqmin))<<endl;
            
            }*/
            //cout<<" bin "<<iy<<" min "<< dchisqmin<<endl;
            
    TCanvas *c8 = new TCanvas();
    c8->cd();
    cpviolation->Draw("hist");
    cpviolation->SetLineWidth(2);
    cpviolation->GetXaxis()->SetTitle("#delta_{CP} [rad.] (True)");
    cpviolation->GetYaxis()->SetTitle("Sigma to exclude sin#delta_{CP} = 0");
    cpviolation->GetYaxis()->SetRangeUser(0,12);
    PrintHisto(c8, "cpviolation");


    TCanvas *c7 = new TCanvas();
    c7->cd();
    dcptrue_rej->Draw("hist");
    dcptrue_rej->SetLineWidth(2);
    dcptrue_rej->GetXaxis()->SetTitle("#delta_{CP} [rad.] (True)");
    dcptrue_rej->GetYaxis()->SetTitle("#sqrt{#Delta #chi^{2}}");
    dcptrue_rej->GetYaxis()->SetRangeUser(0,2);

    PrintHisto(c7, "dcptrue_proj_allexp_th23unknown_0.47");


    TCanvas *c3 = new TCanvas();
    c3->cd();
    SA_th23dcp3D->GetXaxis()->SetTitle("sin^{2}#theta_{23} (Test)");
    SA_th23dcp3D->GetYaxis()->SetTitle("#delta_{CP} (Test)");
    SA_th23dcp3D->GetZaxis()->SetTitle("#delta_{CP} (True)");
    //SA_th23dcp3D->Draw("LEGO");
    //SA_th23dcp3D->SetMaximum(200);
    SA_th23dcp3D->SetFillColor(kBlue);
    SA_th23dcp3D->Draw("ISO");
    PrintHisto(c3, "th23dcp3D_allexp_th23unknown_0.47");
    
    TCanvas *c2 = new TCanvas();
    c2->cd();
    SA_th23dcp->GetXaxis()->SetTitle("sin^{2}#theta_{23} (Test)");
    SA_th23dcp->GetYaxis()->SetTitle("#delta_{CP} (True)");
    SA_th23dcp->Draw("colz");
    SA_th23dcp->GetZaxis()->SetRangeUser(0,100);
    PrintHisto(c2, "th23TestdcpTrue_allexp_th23unknown_0.47");
    
    
    
    
    
    

     TCanvas *c1 = new TCanvas();
    c1->cd();
    SA_dcpTrue_dcpTest->GetXaxis()->SetTitle("#delta_{CP} (Test)");
    SA_dcpTrue_dcpTest->GetYaxis()->SetTitle("#delta_{CP} (True)");
    SA_dcpTrue_dcpTest->Draw("colz");
    SA_dcpTrue_dcpTest->GetZaxis()->SetRangeUser(0,100);
    PrintHisto(c1, "dcpTestdcpTrue_allexp_th23unknown_0.47");
    
     
    TCanvas *c6 = new TCanvas();
    c6->cd();
    SA_dcpTrue_dcpTestRaw->GetXaxis()->SetTitle("#delta_{CP} (Test)");
    SA_dcpTrue_dcpTestRaw->GetYaxis()->SetTitle("#delta_{CP} (True)");
    SA_dcpTrue_dcpTestRaw->Draw("colz");
    SA_dcpTrue_dcpTestRaw->GetZaxis()->SetRangeUser(0,100);
    PrintHisto(c6, "dcpTestdcpTrue_Draw_allexp_th23unknown_0.47");
    
     
     

     
     //to make 68, 90, 99% C.L. contour
    int nlevels = 2;
    //double levels[2] = {1.1395, 2.3025};
    double levels[2] = {2.30, 4.61};
    TString gr_numbers[10] = {"0","1","2","3","4","5","6","7","8","9"};
    TCanvas *c4 = new TCanvas();
    c4->cd();
    TH2D* SA_dcpTrue_dcpTest_cont = (TH2D*)SA_dcpTrue_dcpTest->Clone();
    SA_dcpTrue_dcpTest_cont->SetContour(nlevels, levels);
    SA_dcpTrue_dcpTest_cont->Draw("cont list");
    c4->Update();
    TObjArray *contours_dcpTest_dcpTrue = (TObjArray*)gROOT->GetListOfSpecials()->FindObject("contours");
    if(!contours_dcpTest_dcpTrue){ std::cerr << "quitting!" << std::endl; return; }
    std::vector<TGraph*> gVect_dcpTest_dcpTrue_90;
    std::vector<TGraph*> gVect_dcpTest_dcpTrue_68;
    std::vector<TGraph*> gVect_dcpTest_dcpTrue_conv_90;
    std::vector<TGraph*> gVect_dcpTest_dcpTrue_conv_68;
    gVect_dcpTest_dcpTrue_90 = GetContourGraphs(contours_dcpTest_dcpTrue, "white", 0, 1);
    gVect_dcpTest_dcpTrue_68 = GetContourGraphs(contours_dcpTest_dcpTrue, "white", 0, 0);
    gVect_dcpTest_dcpTrue_conv_90 = GetContourGraphs(contours_dcpTest_dcpTrue, "black", 0, 1);
    gVect_dcpTest_dcpTrue_conv_68 = GetContourGraphs(contours_dcpTest_dcpTrue, "black", 0, 0);
    PreparePlot(SA_dcpTrue_dcpTest);
    SA_dcpTrue_dcpTest->Draw("colz");
    SA_dcpTrue_dcpTest->Write();
    for(int j=0; j<gVect_dcpTest_dcpTrue_90.size(); j++){
        gVect_dcpTest_dcpTrue_90[j]->Draw("Lsame");
        gVect_dcpTest_dcpTrue_90[j]->Write("SA_dcpTrue_dcpTest_cont_90_"+gr_numbers[j]);
        gVect_dcpTest_dcpTrue_conv_90[j]->Write("SA_dcpTrue_dcpTest_cont_conv_90_"+gr_numbers[j]);
    }
    for(int j=0; j<gVect_dcpTest_dcpTrue_68.size(); j++){
        gVect_dcpTest_dcpTrue_68[j]->Draw("Lsame");
        gVect_dcpTest_dcpTrue_68[j]->Write("SA_dcpTrue_dcpTest_cont_68_"+gr_numbers[j]);
        gVect_dcpTest_dcpTrue_conv_68[j]->Write("SA_dcpTrue_dcpTest_cont_conv_68_"+gr_numbers[j]);
    }
    //  best_all->Draw("Psame");
    PrintHisto(c4, "allexp_dcptrue_dcptest_allexp_th23unknown_0.47_contour");
    

 
}

void PrintHisto(TCanvas *canvas, TString name){
    canvas->Print("/home/nhvan/Desktop/Quyen/CPviolation/plots/"+name+".eps");
  //  canvas->Print("/home/quyen/Desktop/th23dcp/plots/allexp/allexp_th23unknown_0.47/"+name+".pdf");
  //  canvas->Print("/home/quyen/Desktop/th23dcp/plots/allexp/allexp_th23unknown_0.47/"+name+".png");
//    canvas->Print("/home/quyen/Desktop/th23dcp/hinh/allexp_known_0.48/"+name+".gif");
//    canvas->Print("/home/quyen/Desktop/th23dcp/hinh/allexp_known_0.48/"+name+".C");
}

//#############################################################################
std::vector<TGraph*> GetContourGraphs(TObjArray *contours, TString color, int twotheta, int graphNum){
    std::vector<TGraph*> gVect;
    double x,y;
    int ncontours = contours->GetEntries();
    std::cout << ncontours << std::endl;
    TList *list = (TList*)contours->At(graphNum);
    std::cout << list->GetEntries() << std::endl;
    
    for(int j=0; j<list->GetEntries(); j++){
        TGraph *gc = new TGraph();
        
        TGraph *gc_temp = (TGraph*)list->At(j);
        int count=0;
        std::cout << "points" << gc_temp->GetN() << std::endl;
        for(int i=0; i<gc_temp->GetN(); i++){
            gc_temp->GetPoint(i, x, y);
            if(twotheta==0){
                gc->SetPoint(i, x, y);
            }
            else{ //switch to sin^2(2 t23)
                //      if(x > 0.5){
                gc->SetPoint(count, 1-TMath::Power(1-2*x, 2), y);
                count++;
                //    }
            }
        }
        gc->SetLineWidth(2);
        gc->SetFillColor(0);
        gc->SetMarkerSize(0);
        
        if(graphNum==0){ gc->SetLineStyle(7); }
        
        if(twotheta==0){
            gc->GetXaxis()->SetLimits(0.3, 0.7);
            gc->GetXaxis()->SetTitle("sin^{2}#theta_{23}");
        }
        else{
            gc->GetXaxis()->SetLimits(0.8, 1.0);
            gc->GetXaxis()->SetTitle("sin^{2}2#theta_{23}");
        }
        gc->GetYaxis()->SetRangeUser(0.0015, 0.004);
        
        gc->GetYaxis()->SetTitle("#Delta m^{2}_{32}");
        
        if(color.Contains("lue")){
            gc->SetLineColor(kBlue);
            gc->SetMarkerColor(kBlue);
        }
        else if(color.Contains("ed")){
            gc->SetLineColor(kRed);
            gc->SetMarkerColor(kRed);
        }
        else if(color.Contains("ack")){
            gc->SetLineColor(kBlack);
            gc->SetMarkerColor(kBlack);
        }
        else if(color.Contains("ite")){
            gc->SetLineColor(kWhite);
            gc->SetMarkerColor(kWhite);
        }
        
        gVect.push_back(gc);
    }
    return gVect;
}

//#############################################################################
void PreparePlot(TH2D* plot){
    plot->GetXaxis()->SetTitle("#delta_{CP} (Test)");
    plot->GetYaxis()->SetTitle("#delta_{CP} (True)");
    TGaxis* gx = (TGaxis*)plot->GetXaxis();
    gx->SetMaxDigits(3);
    TGaxis* gy = (TGaxis*)plot->GetYaxis();
    gy->SetMaxDigits(3);
}
//#############################################################################
void PrepareBestPoint(TGraph* gr){
    gr->SetMarkerStyle(34);
    gr->SetMarkerColor(kRed);
    gr->SetMarkerSize(0.5);
}

void SetStyleVariables(TStyle *t2kStyle){
    
    t2kStyle->SetFrameBorderMode(0);
    t2kStyle->SetCanvasBorderMode(0);
    t2kStyle->SetPadBorderMode(0);
    t2kStyle->SetPadColor(0);
    t2kStyle->SetCanvasColor(0);
    t2kStyle->SetStatColor(0);
    t2kStyle->SetFillColor(0);
    t2kStyle->SetLegendBorderSize(1);
    
    t2kStyle->SetPaperSize(20,26);
    t2kStyle->SetPadTopMargin(0.05);
    t2kStyle->SetPadRightMargin(0.15); //0.05
    t2kStyle->SetPadBottomMargin(0.16);
    t2kStyle->SetPadLeftMargin(0.13);
    
    t2kStyle->SetTextFont(132);
    t2kStyle->SetTextSize(0.08);
    t2kStyle->SetLabelFont(132,"x");
    t2kStyle->SetLabelFont(132,"y");
    t2kStyle->SetLabelFont(132,"z");
    t2kStyle->SetLabelSize(0.05,"x");
    t2kStyle->SetTitleSize(0.06,"x");
    t2kStyle->SetLabelSize(0.05,"y");
    t2kStyle->SetTitleSize(0.06,"y");
    t2kStyle->SetLabelSize(0.05,"z");
    t2kStyle->SetTitleSize(0.06,"z");
    t2kStyle->SetLabelFont(132,"t");
    t2kStyle->SetTitleFont(132,"x");
    t2kStyle->SetTitleFont(132,"y");
    t2kStyle->SetTitleFont(132,"z");
    t2kStyle->SetTitleFont(132,"t");
    t2kStyle->SetTitleFillColor(0);
    t2kStyle->SetTitleX(0.25);
    t2kStyle->SetTitleFontSize(0.08);
    t2kStyle->SetTitleFont(132,"pad");
    
    t2kStyle->SetPadGridX(true);
    t2kStyle->SetPadGridY(true);
    
    
    t2kStyle->SetHistLineWidth(1.85);
    t2kStyle->SetLineStyleString(2,"[12 12]"); // postscript dashes
    
    
    t2kStyle->SetOptTitle(0);
    t2kStyle->SetOptStat(0);
    t2kStyle->SetOptFit(0);
    
    t2kStyle->SetPadTickX(1);
    t2kStyle->SetPadTickY(1);
    
    t2kStyle->SetPalette(1,0);  // use the nice red->blue palette
    const Int_t NRGBs = 5;
    const Int_t NCont = 255;
    
    Double_t stops[NRGBs] = { 0.00, 0.34, 0.61, 0.84, 1.00 };
    Double_t red[NRGBs]   = { 0.00, 0.00, 0.87, 1.00, 0.51 };
    Double_t green[NRGBs] = { 0.00, 0.81, 1.00, 0.20, 0.00 };
    Double_t blue[NRGBs]  = { 0.51, 1.00, 0.12, 0.00, 0.00 };
    TColor::CreateGradientColorTable(NRGBs, stops, red, green, blue,
                                     NCont);
    t2kStyle->SetNumberContours(NCont);
    
}


